diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lr-wpan/model/lr-wpan-mac-pl-headers.h ns-3.39/src/lr-wpan/model/lr-wpan-mac-pl-headers.h
--- ns-3.38/src/lr-wpan/model/lr-wpan-mac-pl-headers.h	2023-03-16 20:54:23.632868500 -0700
+++ ns-3.39/src/lr-wpan/model/lr-wpan-mac-pl-headers.h	2023-07-05 14:23:47.869427400 -0700
@@ -98,6 +98,9 @@
  * \ingroup lr-wpan
  * Implements the header for the MAC payload command frame according to
  * the IEEE 802.15.4-2011 Std.
+ * - Association Response Command (See 5.3.2.2.)
+ * - Coordinator Realigment Command (See 5.3.8.)
+ * - Association Request Command (See 5.3.1.)
  */
 class CommandPayloadHeader : public Header
 {
@@ -160,7 +163,28 @@
      */
     void SetCapabilityField(CapabilityField cap);
     /**
-     * Set the Short Address Assigned by the coordinator (Association Response Command).
+     *  Set the coordinator short address (16 bit address).
+     * \param addr The coordinator short address.
+     */
+    void SetCoordShortAddr(Mac16Address addr);
+    /**
+     *  Set the logical channel number.
+     * \param channel The channel number.
+     */
+    void SetChannel(uint8_t channel);
+    /**
+     *  Set the logical channel page number.
+     * \param page The page number.
+     */
+    void SetPage(uint8_t page);
+    /**
+     * Get the PAN identifier.
+     * \param id The PAN identifier.
+     */
+    void SetPanId(uint16_t id);
+    /**
+     * Set the Short Address Assigned by the coordinator
+     * (Association Response and Coordinator Realigment Commands).
      * \param shortAddr The short address assigned by the coordinator
      */
     void SetShortAddr(Mac16Address shortAddr);
@@ -170,7 +194,8 @@
      */
     void SetAssociationStatus(AssocStatus status);
     /**
-     * Get the Short address assigned by the coordinator (Association Response Command).
+     * Get the Short address assigned by the coordinator
+     * (Association Response and Coordinator Realigment commands).
      * \return The Mac16Address assigned by the coordinator
      */
     Mac16Address GetShortAddr() const;
@@ -185,19 +210,44 @@
      */
     MacCommand GetCommandFrameType() const;
     /**
-     * Get the Capability Information Field from the command payload header. (Association Request
-     * Command)
+     * Get the Capability Information Field from the command payload header.
+     * (Association Request Command)
      * \return The Capability Information Field
      */
     CapabilityField GetCapabilityField() const;
+    /**
+     *  Get the coordinator short address.
+     * \return The coordinator short address (16 bit address)
+     */
+    Mac16Address GetCoordShortAddr() const;
+    /**
+     *  Get the logical channel number.
+     * \return The channel number
+     */
+    uint8_t GetChannel() const;
+    /**
+     *  Get the logical channel page number.
+     * \return The page number.
+     */
+    uint8_t GetPage() const;
+    /**
+     * Get the PAN identifier.
+     * \return The PAN Identifier
+     */
+    uint16_t GetPanId() const;
 
   private:
-    MacCommand m_cmdFrameId; //!< The command Frame Identifier
-    CapabilityField
-        m_capabilityInfo;      //!< Capability Information Field (Association Request Command)
-    Mac16Address m_shortAddr;  //!< Contains the short address assigned by the coordinator
-                               //!< (Association Response Command) See IEEE 802.15.4-2011 5.3.2.2.
-    AssocStatus m_assocStatus; //!< Association Status (Association Response Command)
+    MacCommand m_cmdFrameId;          //!< The command Frame Identifier (Used by all commands)
+    CapabilityField m_capabilityInfo; //!< Capability Information Field
+                                      //!< (Association Request Command)
+    Mac16Address m_shortAddr;         //!< Contains the short address assigned by the coordinator
+                              //!< (Association Response and Coordinator Realiagment Command)
+    Mac16Address m_coordShortAddr; //!< The coordinator short address
+                                   //!< (Coordinator realigment command)
+    uint16_t m_panid;              //!< The PAN identifier (Coordinator realigment command)
+    uint8_t m_logCh;               //!< The channel number (Coordinator realigment command)
+    uint8_t m_logChPage;           //!< The channel page number (Coordinator realigment command)
+    AssocStatus m_assocStatus;     //!< Association Status (Association Response Command)
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lr-wpan/model/lr-wpan-net-device.h ns-3.39/src/lr-wpan/model/lr-wpan-net-device.h
--- ns-3.38/src/lr-wpan/model/lr-wpan-net-device.h	2023-03-16 20:54:23.632868500 -0700
+++ ns-3.39/src/lr-wpan/model/lr-wpan-net-device.h	2023-07-05 14:23:47.869427400 -0700
@@ -250,7 +250,7 @@
      *
      * \param panId The PanID
      * \param shortAddr The Short MAC address
-     * \return a Pseudo-Mac48Adress
+     * \return a Pseudo-Mac48Address
      */
     Mac48Address BuildPseudoMacAddress(uint16_t panId, Mac16Address shortAddr) const;
 
@@ -309,8 +309,8 @@
     /**
      * How the pseudo MAC address is created.
      *
-     * According to \RFC{4944} the psudo-MAC is YYYY:0000:XXXX (with U/L bit set to local)
-     * According to \RFC{6282} the psudo-MAC is 0200:0000:XXXX
+     * According to \RFC{4944} the pseudo-MAC is YYYY:0000:XXXX (with U/L bit set to local)
+     * According to \RFC{6282} the pseudo-MAC is 0200:0000:XXXX
      */
     PseudoMacAddressMode_e m_pseudoMacMode;
 };
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lr-wpan/model/lr-wpan-phy.cc ns-3.39/src/lr-wpan/model/lr-wpan-phy.cc
--- ns-3.38/src/lr-wpan/model/lr-wpan-phy.cc	2023-03-16 20:54:23.632868500 -0700
+++ ns-3.39/src/lr-wpan/model/lr-wpan-phy.cc	2023-07-05 14:23:47.869427400 -0700
@@ -230,7 +230,7 @@
     m_plmeGetAttributeConfirmCallback = MakeNullCallback<void,
                                                          LrWpanPhyEnumeration,
                                                          LrWpanPibAttributeIdentifier,
-                                                         LrWpanPhyPibAttributes*>();
+                                                         Ptr<LrWpanPhyPibAttributes>>();
     m_plmeSetTRXStateConfirmCallback = MakeNullCallback<void, LrWpanPhyEnumeration>();
     m_plmeSetAttributeConfirmCallback =
         MakeNullCallback<void, LrWpanPhyEnumeration, LrWpanPibAttributeIdentifier>();
@@ -737,31 +737,31 @@
 LrWpanPhy::PlmeGetAttributeRequest(LrWpanPibAttributeIdentifier id)
 {
     NS_LOG_FUNCTION(this << id);
-    LrWpanPhyEnumeration status;
+    LrWpanPhyEnumeration status = IEEE_802_15_4_PHY_SUCCESS;
+    Ptr<LrWpanPhyPibAttributes> attributes = Create<LrWpanPhyPibAttributes>();
 
     switch (id)
     {
     case phyCurrentChannel:
-    case phyChannelsSupported:
-    case phyTransmitPower:
-    case phyCCAMode:
+        attributes->phyCurrentChannel = m_phyPIBAttributes.phyCurrentChannel;
+        break;
     case phyCurrentPage:
-    case phyMaxFrameDuration:
+        attributes->phyCurrentPage = m_phyPIBAttributes.phyCurrentPage;
+        break;
     case phySHRDuration:
-    case phySymbolsPerOctet: {
-        status = IEEE_802_15_4_PHY_SUCCESS;
+        attributes->phySHRDuration = GetPhySHRDuration();
         break;
-    }
-    default: {
+    case phySymbolsPerOctet:
+        attributes->phySymbolsPerOctet = GetPhySymbolsPerOctet();
+        break;
+    default:
         status = IEEE_802_15_4_PHY_UNSUPPORTED_ATTRIBUTE;
         break;
     }
-    }
+
     if (!m_plmeGetAttributeConfirmCallback.IsNull())
     {
-        LrWpanPhyPibAttributes retValue;
-        memcpy(&retValue, &m_phyPIBAttributes, sizeof(LrWpanPhyPibAttributes));
-        m_plmeGetAttributeConfirmCallback(status, id, &retValue);
+        m_plmeGetAttributeConfirmCallback(status, id, attributes);
     }
 }
 
@@ -996,7 +996,7 @@
 
 void
 LrWpanPhy::PlmeSetAttributeRequest(LrWpanPibAttributeIdentifier id,
-                                   LrWpanPhyPibAttributes* attribute)
+                                   Ptr<LrWpanPhyPibAttributes> attribute)
 {
     NS_LOG_FUNCTION(this << id << attribute);
     NS_ASSERT(attribute);
@@ -1484,7 +1484,7 @@
     NS_ABORT_IF((m_trxState != IEEE_802_15_4_PHY_BUSY_TX) &&
                 (m_trxState != IEEE_802_15_4_PHY_TRX_OFF));
 
-    if (m_currentTxPacket.second == false)
+    if (!m_currentTxPacket.second)
     {
         NS_LOG_DEBUG("Packet successfully transmitted");
         m_phyTxEndTrace(m_currentTxPacket.first);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lr-wpan/model/lr-wpan-phy.h ns-3.39/src/lr-wpan/model/lr-wpan-phy.h
--- ns-3.38/src/lr-wpan/model/lr-wpan-phy.h	2023-03-16 20:54:23.632868500 -0700
+++ ns-3.39/src/lr-wpan/model/lr-wpan-phy.h	2023-07-05 14:23:47.869427400 -0700
@@ -156,7 +156,7 @@
  *
  * IEEE802.15.4-2006 PHY PIB Attributes Table 23 in section 6.4.2
  */
-struct LrWpanPhyPibAttributes
+struct LrWpanPhyPibAttributes : public SimpleRefCount<LrWpanPhyPibAttributes>
 {
     uint8_t phyCurrentChannel;         //!< The RF channel to use
     uint32_t phyChannelsSupported[32]; //!< BitField representing the available channels supported
@@ -218,7 +218,10 @@
  * @param id the identifier of attribute
  * @param attribute the pointer to attribute struct
  */
-typedef Callback<void, LrWpanPhyEnumeration, LrWpanPibAttributeIdentifier, LrWpanPhyPibAttributes*>
+typedef Callback<void,
+                 LrWpanPhyEnumeration,
+                 LrWpanPibAttributeIdentifier,
+                 Ptr<LrWpanPhyPibAttributes>>
     PlmeGetAttributeConfirmCallback;
 
 /**
@@ -395,7 +398,7 @@
      * \param attribute the attribute value
      */
     void PlmeSetAttributeRequest(LrWpanPibAttributeIdentifier id,
-                                 LrWpanPhyPibAttributes* attribute);
+                                 Ptr<LrWpanPhyPibAttributes> attribute);
 
     /**
      * set the callback for the end of a RX, as part of the
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lr-wpan/test/examples-to-run.py ns-3.39/src/lr-wpan/test/examples-to-run.py
--- ns-3.38/src/lr-wpan/test/examples-to-run.py	2023-03-16 20:54:23.632868500 -0700
+++ ns-3.39/src/lr-wpan/test/examples-to-run.py	2023-07-05 14:23:47.869427400 -0700
@@ -1,5 +1,4 @@
 #! /usr/bin/env python3
-## -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-
 
 # A list of C++ examples to run in order to ensure that they remain
 # buildable and runnable over time.  Each tuple in the list contains
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lr-wpan/test/lr-wpan-mac-test.cc ns-3.39/src/lr-wpan/test/lr-wpan-mac-test.cc
--- ns-3.38/src/lr-wpan/test/lr-wpan-mac-test.cc	2023-03-16 20:54:23.632868500 -0700
+++ ns-3.39/src/lr-wpan/test/lr-wpan-mac-test.cc	2023-07-05 14:23:47.869427400 -0700
@@ -488,27 +488,216 @@
     NS_TEST_EXPECT_MSG_EQ(m_panDescriptorList.size(),
                           2,
                           "Error, Beacons not received or PAN descriptors not found");
-    NS_TEST_ASSERT_MSG_LT(m_panDescriptorList[0].m_linkQuality,
-                          255,
-                          "Error, Coordinator 1 (PAN 5) LQI value should be less than 255.");
-    NS_TEST_ASSERT_MSG_LT(m_panDescriptorList[1].m_linkQuality,
-                          255,
-                          "Error, Coordinator 2 (PAN 7) LQI value should be less than 255.");
-    NS_TEST_ASSERT_MSG_GT(m_panDescriptorList[0].m_linkQuality,
-                          0,
-                          "Error, Coordinator 1 (PAN 5) LQI value should be greater than 0.");
-    NS_TEST_ASSERT_MSG_GT(m_panDescriptorList[1].m_linkQuality,
-                          0,
-                          "Error, Coordinator 2 (PAN 7) LQI value should be greater than 0.");
-
-    NS_TEST_ASSERT_MSG_LT(
-        m_panDescriptorList[1].m_linkQuality,
-        m_panDescriptorList[0].m_linkQuality,
-        "Error, Coordinator 2 (PAN 7) LQI value should be less than Coordinator 1 (PAN 5).");
-
-    NS_TEST_EXPECT_MSG_EQ(g_beaconPayloadSize,
-                          25,
-                          "Error, Beacon Payload not received or incorrect size (25 bytes)");
+
+    if (m_panDescriptorList.size() == 2)
+    {
+        NS_TEST_ASSERT_MSG_LT(m_panDescriptorList[0].m_linkQuality,
+                              255,
+                              "Error, Coordinator 1 (PAN 5) LQI value should be less than 255.");
+        NS_TEST_ASSERT_MSG_LT(m_panDescriptorList[1].m_linkQuality,
+                              255,
+                              "Error, Coordinator 2 (PAN 7) LQI value should be less than 255.");
+        NS_TEST_ASSERT_MSG_GT(m_panDescriptorList[0].m_linkQuality,
+                              0,
+                              "Error, Coordinator 1 (PAN 5) LQI value should be greater than 0.");
+        NS_TEST_ASSERT_MSG_GT(m_panDescriptorList[1].m_linkQuality,
+                              0,
+                              "Error, Coordinator 2 (PAN 7) LQI value should be greater than 0.");
+
+        NS_TEST_ASSERT_MSG_LT(m_panDescriptorList[1].m_linkQuality,
+                              m_panDescriptorList[0].m_linkQuality,
+                              "Error, Coordinator 2 (PAN 7) LQI value should"
+                              " be less than Coordinator 1 (PAN 5).");
+
+        NS_TEST_EXPECT_MSG_EQ(g_beaconPayloadSize,
+                              25,
+                              "Error, Beacon Payload not received or incorrect size (25 bytes)");
+    }
+
+    Simulator::Destroy();
+}
+
+/**
+ * \ingroup lr-wpan-test
+ * \ingroup tests
+ *
+ * \brief Test MAC Orphan Scan Coordinator Realignment command reception and its values.
+ */
+class TestOrphanScan : public TestCase
+{
+  public:
+    TestOrphanScan();
+    ~TestOrphanScan() override;
+
+  private:
+    /**
+     * Function called in response to a MAC scan request.
+     *
+     * \param params MLME scan confirm parameters
+     */
+    void ScanConfirm(MlmeScanConfirmParams params);
+
+    /**
+     * Function called as a result of receiving an orphan notification command
+     * on the coordinator
+     *
+     * \param params MLME orphan indication parameters
+     */
+    void OrphanIndicationCoord(MlmeOrphanIndicationParams params);
+
+    void DoRun() override;
+
+    Ptr<LrWpanNetDevice> coord1NetDevice;  //!< The LrWpanNetDevice of coordinator 1
+    Ptr<LrWpanNetDevice> endNodeNetDevice; //!< The LrWpanNetDevice of the end device
+    bool m_orphanScanSuccess;              //!< Indicates a successful orphan scan
+};
+
+TestOrphanScan::TestOrphanScan()
+    : TestCase("Test an orphan scan and the reception of the commands involved")
+{
+    m_orphanScanSuccess = false;
+}
+
+TestOrphanScan::~TestOrphanScan()
+{
+}
+
+void
+TestOrphanScan::ScanConfirm(MlmeScanConfirmParams params)
+{
+    if (params.m_status == MLMESCAN_SUCCESS)
+    {
+        m_orphanScanSuccess = true;
+    }
+}
+
+void
+TestOrphanScan::OrphanIndicationCoord(MlmeOrphanIndicationParams params)
+{
+    // The steps taken by the coordinator on the event of an orphan indication
+    // are meant to be implemented by the next higher layer and are out of the scope of the
+    // standard. In this test, we assume that coordinator 2 already has
+    // the endDevice [00:00:00:00:00:00:00:03] registered and therefore reply to this device
+    // a with a coordidinator realignment command.
+
+    if (params.m_orphanAddr == Mac64Address("00:00:00:00:00:00:00:02"))
+    {
+        MlmeOrphanResponseParams respParams;
+        respParams.m_assocMember = true;
+        respParams.m_orphanAddr = params.m_orphanAddr;
+        respParams.m_shortAddr = Mac16Address("00:02");
+
+        Simulator::ScheduleNow(&LrWpanMac::MlmeOrphanResponse,
+                               coord1NetDevice->GetMac(),
+                               respParams);
+    }
+}
+
+void
+TestOrphanScan::DoRun()
+{
+    // Create 2 PAN coordinator nodes, and 1 end device
+    Ptr<Node> coord1 = CreateObject<Node>();
+    Ptr<Node> endNode = CreateObject<Node>();
+
+    coord1NetDevice = CreateObject<LrWpanNetDevice>();
+    endNodeNetDevice = CreateObject<LrWpanNetDevice>();
+
+    // PAN Coordinators configurations require to set both, the EUI-64 (extended address)
+    // and to assign their own short address.
+    coord1NetDevice->GetMac()->SetExtendedAddress(Mac64Address("00:00:00:00:00:00:00:01"));
+    coord1NetDevice->GetMac()->SetShortAddress(Mac16Address("00:01"));
+
+    // Other devices must have only its EUI-64 and later on, their short address is
+    // potentially assigned by the coordinator.
+    endNodeNetDevice->GetMac()->SetExtendedAddress(Mac64Address("00:00:00:00:00:00:00:02"));
+
+    // Configure Spectrum channel
+    Ptr<SingleModelSpectrumChannel> channel = CreateObject<SingleModelSpectrumChannel>();
+    Ptr<LogDistancePropagationLossModel> propModel =
+        CreateObject<LogDistancePropagationLossModel>();
+    Ptr<ConstantSpeedPropagationDelayModel> delayModel =
+        CreateObject<ConstantSpeedPropagationDelayModel>();
+    channel->AddPropagationLossModel(propModel);
+    channel->SetPropagationDelayModel(delayModel);
+
+    coord1NetDevice->SetChannel(channel);
+    endNodeNetDevice->SetChannel(channel);
+
+    coord1->AddDevice(coord1NetDevice);
+    endNode->AddDevice(endNodeNetDevice);
+
+    // Mobility
+    Ptr<ConstantPositionMobilityModel> coord1Mobility =
+        CreateObject<ConstantPositionMobilityModel>();
+    coord1Mobility->SetPosition(Vector(0, 0, 0));
+    coord1NetDevice->GetPhy()->SetMobility(coord1Mobility);
+
+    Ptr<ConstantPositionMobilityModel> endNodeMobility =
+        CreateObject<ConstantPositionMobilityModel>();
+    endNodeMobility->SetPosition(Vector(100, 0, 0));
+    endNodeNetDevice->GetPhy()->SetMobility(endNodeMobility);
+
+    // MAC layer Callbacks hooks
+    MlmeScanConfirmCallback cb1;
+    cb1 = MakeCallback(&TestOrphanScan::ScanConfirm, this);
+    endNodeNetDevice->GetMac()->SetMlmeScanConfirmCallback(cb1);
+
+    MlmeOrphanIndicationCallback cb2;
+    cb2 = MakeCallback(&TestOrphanScan::OrphanIndicationCoord, this);
+    coord1NetDevice->GetMac()->SetMlmeOrphanIndicationCallback(cb2);
+    /////////////////
+    // ORPHAN SCAN //
+    /////////////////
+
+    // PAN coordinator N0 (PAN 5) is set to channel 12 in non-beacon mode
+    // but answer to beacon request and orphan notification commands.
+    MlmeStartRequestParams params;
+    params.m_panCoor = true;
+    params.m_PanId = 5;
+    params.m_bcnOrd = 15;
+    params.m_sfrmOrd = 15;
+    params.m_logCh = 12;
+    Simulator::ScheduleWithContext(1,
+                                   Seconds(2.0),
+                                   &LrWpanMac::MlmeStartRequest,
+                                   coord1NetDevice->GetMac(),
+                                   params);
+
+    // End device N1 is set to scan 4 channels looking for the presence of a coordinator.
+    // On each channel, a single orphan notification command is sent and a response is
+    // waited for a maximum time of macResponseWaitTime. If a reply is received from a
+    // coordinator within this time (coordinator realignment command), the programmed scans on
+    // other channels is suspended.
+    // Scan Channels are represented by bits 0-26  (27 LSB)
+    //                       ch 14  ch 11
+    //                           |  |
+    // 0x7800  = 0000000000000000111100000000000
+    MlmeScanRequestParams scanParams;
+    scanParams.m_chPage = 0;
+    scanParams.m_scanChannels = 0x7800;
+    scanParams.m_scanType = MLMESCAN_ORPHAN;
+    Simulator::ScheduleWithContext(1,
+                                   Seconds(3.0),
+                                   &LrWpanMac::MlmeScanRequest,
+                                   endNodeNetDevice->GetMac(),
+                                   scanParams);
+
+    Simulator::Stop(Seconds(4000));
+    NS_LOG_DEBUG("----------- Start of TestOrphanScan -------------------");
+    Simulator::Run();
+
+    NS_TEST_EXPECT_MSG_EQ(m_orphanScanSuccess,
+                          true,
+                          "Error, no coordinator realignment commands"
+                          " received during orphan scan");
+    if (m_orphanScanSuccess)
+    {
+        NS_TEST_EXPECT_MSG_EQ(endNodeNetDevice->GetMac()->GetShortAddress(),
+                              Mac16Address("00:02"),
+                              "Error, end device did not receive short address"
+                              " during orphan scan");
+    }
 
     Simulator::Destroy();
 }
@@ -530,6 +719,7 @@
 {
     AddTestCase(new TestRxOffWhenIdleAfterCsmaFailure, TestCase::QUICK);
     AddTestCase(new TestActiveScanPanDescriptors, TestCase::QUICK);
+    AddTestCase(new TestOrphanScan, TestCase::QUICK);
 }
 
 static LrWpanMacTestSuite g_lrWpanMacTestSuite; //!< Static variable for test initialization
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/examples/lena-cqi-threshold.cc ns-3.39/src/lte/examples/lena-cqi-threshold.cc
--- ns-3.38/src/lte/examples/lena-cqi-threshold.cc	2023-03-16 20:54:23.660868600 -0700
+++ ns-3.39/src/lte/examples/lena-cqi-threshold.cc	2023-07-05 14:23:47.897427600 -0700
@@ -113,7 +113,7 @@
     Simulator::Schedule(Seconds(0.020), &ChangePosition, ueNodes.Get(0));
 
     // Activate a data radio bearer
-    enum EpsBearer::Qci q = EpsBearer::GBR_CONV_VOICE;
+    EpsBearer::Qci q = EpsBearer::GBR_CONV_VOICE;
     EpsBearer bearer(q);
     lteHelper->ActivateDataRadioBearer(ueDevs, bearer);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/examples/lena-deactivate-bearer.cc ns-3.39/src/lte/examples/lena-deactivate-bearer.cc
--- ns-3.38/src/lte/examples/lena-deactivate-bearer.cc	2023-03-16 20:54:23.660868600 -0700
+++ ns-3.39/src/lte/examples/lena-deactivate-bearer.cc	2023-07-05 14:23:47.897427600 -0700
@@ -153,7 +153,7 @@
         qos.mbrDl = qos.gbrDl;
         qos.mbrUl = qos.gbrUl;
 
-        enum EpsBearer::Qci q = EpsBearer::GBR_CONV_VOICE;
+        EpsBearer::Qci q = EpsBearer::GBR_CONV_VOICE;
         EpsBearer bearer(q, qos);
         bearer.arp.priorityLevel = 15 - (u + 1);
         bearer.arp.preemptionCapability = true;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/examples/lena-dual-stripe.cc ns-3.39/src/lte/examples/lena-dual-stripe.cc
--- ns-3.38/src/lte/examples/lena-dual-stripe.cc	2023-03-16 20:54:23.660868600 -0700
+++ ns-3.39/src/lte/examples/lena-dual-stripe.cc	2023-07-05 14:23:47.897427600 -0700
@@ -948,7 +948,7 @@
             Ptr<NetDevice> ueDev = ueDevs.Get(u);
             for (uint32_t b = 0; b < numBearersPerUe; ++b)
             {
-                enum EpsBearer::Qci q = EpsBearer::NGBR_VIDEO_TCP_DEFAULT;
+                EpsBearer::Qci q = EpsBearer::NGBR_VIDEO_TCP_DEFAULT;
                 EpsBearer bearer(q);
                 lteHelper->ActivateDataRadioBearer(ueDev, bearer);
             }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/examples/lena-fading.cc ns-3.39/src/lte/examples/lena-fading.cc
--- ns-3.38/src/lte/examples/lena-fading.cc	2023-03-16 20:54:23.660868600 -0700
+++ ns-3.39/src/lte/examples/lena-fading.cc	2023-07-05 14:23:47.897427600 -0700
@@ -112,7 +112,7 @@
     lteHelper->Attach(ueDevs, enbDevs.Get(0));
 
     // Activate an EPS bearer
-    enum EpsBearer::Qci q = EpsBearer::GBR_CONV_VOICE;
+    EpsBearer::Qci q = EpsBearer::GBR_CONV_VOICE;
     EpsBearer bearer(q);
     lteHelper->ActivateDataRadioBearer(ueDevs, bearer);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/examples/lena-frequency-reuse.cc ns-3.39/src/lte/examples/lena-frequency-reuse.cc
--- ns-3.38/src/lte/examples/lena-frequency-reuse.cc	2023-03-16 20:54:23.660868600 -0700
+++ ns-3.39/src/lte/examples/lena-frequency-reuse.cc	2023-07-05 14:23:47.897427600 -0700
@@ -325,7 +325,7 @@
     lteHelper->AttachToClosestEnb(randomUeDevs, enbDevs);
 
     // Activate a data radio bearer
-    enum EpsBearer::Qci q = EpsBearer::GBR_CONV_VOICE;
+    EpsBearer::Qci q = EpsBearer::GBR_CONV_VOICE;
     EpsBearer bearer(q);
     lteHelper->ActivateDataRadioBearer(edgeUeDevs, bearer);
     lteHelper->ActivateDataRadioBearer(centerUeDevs, bearer);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/examples/lena-intercell-interference.cc ns-3.39/src/lte/examples/lena-intercell-interference.cc
--- ns-3.38/src/lte/examples/lena-intercell-interference.cc	2023-03-16 20:54:23.660868600 -0700
+++ ns-3.39/src/lte/examples/lena-intercell-interference.cc	2023-07-05 14:23:47.897427600 -0700
@@ -126,7 +126,7 @@
     lteHelper->Attach(ueDevs2, enbDevs.Get(1));
 
     // Activate a data radio bearer each UE
-    enum EpsBearer::Qci q = EpsBearer::GBR_CONV_VOICE;
+    EpsBearer::Qci q = EpsBearer::GBR_CONV_VOICE;
     EpsBearer bearer(q);
     lteHelper->ActivateDataRadioBearer(ueDevs1, bearer);
     lteHelper->ActivateDataRadioBearer(ueDevs2, bearer);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/examples/lena-pathloss-traces.cc ns-3.39/src/lte/examples/lena-pathloss-traces.cc
--- ns-3.38/src/lte/examples/lena-pathloss-traces.cc	2023-03-16 20:54:23.660868600 -0700
+++ ns-3.39/src/lte/examples/lena-pathloss-traces.cc	2023-07-05 14:23:47.901427700 -0700
@@ -136,7 +136,7 @@
     lteHelper->Attach(ueDevs2, enbDevs.Get(1));
 
     // Activate an EPS bearer on all UEs
-    enum EpsBearer::Qci q = EpsBearer::GBR_CONV_VOICE;
+    EpsBearer::Qci q = EpsBearer::GBR_CONV_VOICE;
     EpsBearer bearer(q);
     lteHelper->ActivateDataRadioBearer(ueDevs1, bearer);
     lteHelper->ActivateDataRadioBearer(ueDevs2, bearer);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/examples/lena-profiling.cc ns-3.39/src/lte/examples/lena-profiling.cc
--- ns-3.38/src/lte/examples/lena-profiling.cc	2023-03-16 20:54:23.660868600 -0700
+++ ns-3.39/src/lte/examples/lena-profiling.cc	2023-07-05 14:23:47.901427700 -0700
@@ -184,7 +184,7 @@
         NetDeviceContainer ueDev = lteHelper->InstallUeDevice(ueNodes.at(i));
         ueDevs.push_back(ueDev);
         lteHelper->Attach(ueDev, enbDevs.Get(i));
-        enum EpsBearer::Qci q = EpsBearer::GBR_CONV_VOICE;
+        EpsBearer::Qci q = EpsBearer::GBR_CONV_VOICE;
         EpsBearer bearer(q);
         lteHelper->ActivateDataRadioBearer(ueDev, bearer);
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/examples/lena-radio-link-failure.cc ns-3.39/src/lte/examples/lena-radio-link-failure.cc
--- ns-3.38/src/lte/examples/lena-radio-link-failure.cc	2023-03-16 20:54:23.660868600 -0700
+++ ns-3.39/src/lte/examples/lena-radio-link-failure.cc	2023-07-05 14:23:47.901427700 -0700
@@ -318,7 +318,7 @@
 {
     std::ofstream output;
 
-    if (firstWrite == true)
+    if (firstWrite)
     {
         output.open(fileName, std::ofstream::out);
         firstWrite = false;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/examples/lena-rem.cc ns-3.39/src/lte/examples/lena-rem.cc
--- ns-3.38/src/lte/examples/lena-rem.cc	2023-03-16 20:54:23.660868600 -0700
+++ ns-3.39/src/lte/examples/lena-rem.cc	2023-07-05 14:23:47.901427700 -0700
@@ -84,7 +84,7 @@
     lteHelper->Attach(ueDevs, enbDevs.Get(0));
 
     // Activate an EPS bearer
-    enum EpsBearer::Qci q = EpsBearer::GBR_CONV_VOICE;
+    EpsBearer::Qci q = EpsBearer::GBR_CONV_VOICE;
     EpsBearer bearer(q);
     lteHelper->ActivateDataRadioBearer(ueDevs, bearer);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/examples/lena-rem-sector-antenna.cc ns-3.39/src/lte/examples/lena-rem-sector-antenna.cc
--- ns-3.38/src/lte/examples/lena-rem-sector-antenna.cc	2023-03-16 20:54:23.660868600 -0700
+++ ns-3.39/src/lte/examples/lena-rem-sector-antenna.cc	2023-07-05 14:23:47.901427700 -0700
@@ -198,7 +198,7 @@
         NetDeviceContainer ueDev = lteHelper->InstallUeDevice(ueNodes.at(i));
         ueDevs.push_back(ueDev);
         lteHelper->Attach(ueDev, enbDevs.Get(i));
-        enum EpsBearer::Qci q = EpsBearer::GBR_CONV_VOICE;
+        EpsBearer::Qci q = EpsBearer::GBR_CONV_VOICE;
         EpsBearer bearer(q);
         lteHelper->ActivateDataRadioBearer(ueDev, bearer);
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/examples/lena-rlc-traces.cc ns-3.39/src/lte/examples/lena-rlc-traces.cc
--- ns-3.38/src/lte/examples/lena-rlc-traces.cc	2023-03-16 20:54:23.660868600 -0700
+++ ns-3.39/src/lte/examples/lena-rlc-traces.cc	2023-07-05 14:23:47.901427700 -0700
@@ -67,7 +67,7 @@
     lteHelper->Attach(ueDevs, enbDevs.Get(0));
 
     // Activate an EPS bearer
-    enum EpsBearer::Qci q = EpsBearer::GBR_CONV_VOICE;
+    EpsBearer::Qci q = EpsBearer::GBR_CONV_VOICE;
     EpsBearer bearer(q);
     lteHelper->ActivateDataRadioBearer(ueDevs, bearer);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/examples/lena-simple.cc ns-3.39/src/lte/examples/lena-simple.cc
--- ns-3.38/src/lte/examples/lena-simple.cc	2023-03-16 20:54:23.660868600 -0700
+++ ns-3.39/src/lte/examples/lena-simple.cc	2023-07-05 14:23:47.901427700 -0700
@@ -95,7 +95,7 @@
     lteHelper->Attach(ueDevs, enbDevs.Get(0));
 
     // Activate a data radio bearer
-    enum EpsBearer::Qci q = EpsBearer::GBR_CONV_VOICE;
+    EpsBearer::Qci q = EpsBearer::GBR_CONV_VOICE;
     EpsBearer bearer(q);
     lteHelper->ActivateDataRadioBearer(ueDevs, bearer);
     lteHelper->EnableTraces();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/examples/lena-simple-epc-backhaul.cc ns-3.39/src/lte/examples/lena-simple-epc-backhaul.cc
--- ns-3.38/src/lte/examples/lena-simple-epc-backhaul.cc	2023-03-16 20:54:23.660868600 -0700
+++ ns-3.39/src/lte/examples/lena-simple-epc-backhaul.cc	2023-07-05 14:23:47.901427700 -0700
@@ -158,7 +158,7 @@
         for (uint16_t i = 0; i < numNodePairs; ++i)
         {
             Ptr<Node> enb = enbNodes.Get(i);
-            std::vector<uint16_t> cellIds(1, i);
+            std::vector<uint16_t> cellIds(1, i + 1);
 
             // Create a point to point link between the eNB and the SGW with
             // the corresponding new NetDevices on each side
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/examples/lena-uplink-power-control.cc ns-3.39/src/lte/examples/lena-uplink-power-control.cc
--- ns-3.38/src/lte/examples/lena-uplink-power-control.cc	2023-03-16 20:54:23.660868600 -0700
+++ ns-3.39/src/lte/examples/lena-uplink-power-control.cc	2023-07-05 14:23:47.901427700 -0700
@@ -91,7 +91,7 @@
     lteHelper->Attach(ueDevs, enbDevs.Get(0));
 
     // Activate a data radio bearer
-    enum EpsBearer::Qci q = EpsBearer::GBR_CONV_VOICE;
+    EpsBearer::Qci q = EpsBearer::GBR_CONV_VOICE;
     EpsBearer bearer(q);
     lteHelper->ActivateDataRadioBearer(ueDevs, bearer);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/helper/emu-epc-helper.cc ns-3.39/src/lte/helper/emu-epc-helper.cc
--- ns-3.38/src/lte/helper/emu-epc-helper.cc	2023-03-16 20:54:23.660868600 -0700
+++ ns-3.39/src/lte/helper/emu-epc-helper.cc	2023-07-05 14:23:47.901427700 -0700
@@ -19,7 +19,7 @@
  *         Manuel Requena <manuel.requena@cttc.es>
  */
 
-#include "ns3/emu-epc-helper.h"
+#include "emu-epc-helper.h"
 
 #include "ns3/emu-fd-net-device-helper.h"
 #include "ns3/epc-x2.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/helper/emu-epc-helper.h ns-3.39/src/lte/helper/emu-epc-helper.h
--- ns-3.38/src/lte/helper/emu-epc-helper.h	2023-03-16 20:54:23.660868600 -0700
+++ ns-3.39/src/lte/helper/emu-epc-helper.h	2023-07-05 14:23:47.901427700 -0700
@@ -22,7 +22,7 @@
 #ifndef EMU_EPC_HELPER_H
 #define EMU_EPC_HELPER_H
 
-#include "ns3/no-backhaul-epc-helper.h"
+#include "no-backhaul-epc-helper.h"
 
 namespace ns3
 {
